<%-- Defines the programming langauge used in this page --%>
<%@ page language="java" %>
<%@ page isELIgnored="false" %> 

<%-- Imports the tag libraries to be used in this page--%>
<%@ taglib prefix="sms"  uri="/WEB-INF/tlds/SMSTags.tld" 			 %>
<%@ taglib prefix="smsU" uri="/WEB-INF/tlds/SMSUtils.tld" 			 %>
<%@ taglib prefix="str"  uri="/WEB-INF/tlds/taglibs-string.tld" 	 %>
<%@ taglib prefix="c"    uri="http://java.sun.com/jsp/jstl/core" 	 %>
<%@ taglib prefix="x"    uri="http://java.sun.com/jsp/jstl/xml" 	 %>
<%@ taglib prefix="fn"   uri="http://java.sun.com/jsp/jstl/functions"%>
<%@ taglib prefix="fmt"  uri="http://java.sun.com/jsp/jstl/fmt" 	 %>
<%@ taglib prefix="sql"  uri="http://java.sun.com/jsp/jstl/sql" 	 %>
<%@ taglib prefix="f" uri="http://www.dlese.org/dpc/dds/tags/dleseELFunctions" %>
<%-- Get the URL to the local CSIP --%>
<c:set var="smsCsipBaseUrl" value="${initParam.smsCsipBaseUrl}" />

<%-- Sets the default host,port and path for rest of the tags used in this page --%>
<smsU:DefaultHost host="${initParam.smsCsipHost}"/> 
<smsU:DefaultPort port="${initParam.smsCsipPort}"/> 
<smsU:DefaultPath path="/${initParam.smsCsipContext}/Query"/> 

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<html>
<head>
<title>Strand Map Service - Educational Benchmark Collection</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link rel="stylesheet" type="text/css" href="./dlese_shared/dlese_styles_screen.css"/>
<link rel="stylesheet" type="text/css" href="./dlese_shared/dlese_styles_menus_only.css"/>
<link rel='stylesheet' type='text/css' href='./dlese_shared/sms_styles.css'>

<script type="text/javascript" language="javascript">
function updateMaps(){
	// get selected chapter
	// send to a jsp via ajax
	// pull in a list of related maps for that chapter
	// using dom, update the map list	
}
</script>

</head>

<body>

<c:set var="AllMaps" value="${param.AllMaps}" />
<table width="800" border="0" cellpadding="0" cellspacing="0" bgcolor="#DEF0F5">
  <tr>
    <td width="21" rowspan="4" valign="top" bgcolor="#FFFFFF"><img src="images/vert.png" alt="" width="12" height="502" /></td>  
    <td height="110" colspan="2" valign="top">
    	<table border="0" width="100%" cellpadding="0" cellspacing="0">
    		<tr>
    			<td>
			    	<img src="images/nsdlTopBanner.png" alt="Strand Maps Service Educational Benchmarks Collection" width="800" height="110" />
		    	</td>
	    	</tr>
	    	<tr>
				<!-- The content of index page goes here -->
	    		<td>
					<p>This is a collection of benchmarks, more generically called learning goals, describing what students should know or be able to do by the end of grades 2, 5, 8, and 12 in order to become scientifically literate.  The list of benchmarks was published as the book Benchmarks for Science Literacy in 1993.</p>
					<p>Please use the drop down menus to select topic and grade specific benchmarks.</p>
					<hr width="100%">

					<p>		
								
						<c:if test="${param.CN1 != null && param.CN1 != ''}">
							<str:split separator=":" var="stdgrd"><c:out value="${param.CN1}"/></str:split>
						</c:if>	
						
						<table border="0" width="770" cellpadding="0" id="pot">
							<tr align="center"><td width="35%"><b>Select a Topic</b></td><td width="1"></td><td><b>Educational Benchmarks</b></td></tr>
							<tr align="center">
								<td width="35%" valign="top">
									<form action="" id="cc" onchange="getElementById('cc').submit()">
										<sms:DropDownList name="chapter" topLabel="Select a chapter to limit maps..."><sms:ChapterList/></sms:DropDownList>
									</form>
									<form action="" id="mm" onchange="getElementById('mm').submit()">
										<input type="hidden" name="chapter" value="${chapter}"/>
										<select name="AllMaps">
										<option value="">Please select a map ...</option>
										<x:parse var="Clusters">
											<sms:ClusterList upper="${chapter}"/> 
										</x:parse>
										<x:transform xslt="${f:removeNamespacesXsl()}" xml="${Clusters}" var="clusterXML"/>	
										<%-- get total maps --%>
										<x:forEach select="$clusterXML//itemRecord">
											<c:set var="clusterNumber"><x:out select="Admin/IDNumber"/></c:set>
											<x:parse var="Maps">
												<sms:MapList upper="${clusterNumber}"/> 
											</x:parse>
											<x:transform xslt="${f:removeNamespacesXsl()}" xml="${Maps}" var="mapXML"/>	
											<x:forEach select="$mapXML//itemRecord">
												<c:set var="mapId"><x:out select="Admin/IDNumber"/></c:set>
												<c:choose>
													<c:when test="${AllMaps == mapId}">
														<option value="${mapId}" selected="selected"><x:out select="Data/Name"/></option>
													</c:when>
													<c:otherwise>
														<option value="${mapId}"><x:out select="Data/Name"/></option>
													</c:otherwise>
												</c:choose>
												
											</x:forEach>
										</x:forEach>
										</select><img onclick="getElementById('mm').submit()" style="cursor: pointer" src="./images/reload.jpg" alt="Reload Benchmarks" />
										<input type="hidden" name="CN1" />	
									</form>
									
									
									<c:if test="${AllMaps != null && AllMaps != ''}">
									
										<form action="">
											<input type="hidden" name="chapter" value="${chapter}" />
											<input type="hidden" name="AllMaps" value="${AllMaps}" />
											<sms:ClusterNavigator attach="AllMaps" name="CN1" width="300"/>
										</form>
									
										<hr>
										<br>
									
										<a href="/?id=${AllMaps}" target="_blank">
											<b>Explore Relationships between Educational Benchmarks</b></a>
											<br><br>
	   										<a href="/?id=${AllMaps}" target="_blank"><img src="/cms1-2/jsapi/map_images/8ECF8E/4/20/${AllMaps}.JPG" alt="View this map in the Science Literacy Maps Browser"/></a> 
										</a>
									</c:if>
								</td>
								
								
								<%-- vertical seperator between the two content columns--%>
								<td width="1" bgcolor="lightgrey"></td>
								
								
								<%-- Benchmark names and lines go here --%>
								<td align="left" valign="top">
									<c:url var="getAllBmks" value="${smsCsipBaseUrl}/Query">
										<c:param name="Query">
											<c:choose>
												<c:when test="${param.CN1 != null && param.CN1 != ''}">
													<SMS-CSIP xmlns="http://sms.dlese.org" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
														<Query Color="skyblue" Format="SMS">
															<Content-Query>
																<InternalRelationships>
																	<InternalRelationship Relation="Is part of" Object="<c:out value='${stdgrd[0]}'/>"></InternalRelationship>
																	<InternalRelationship Relation="Is part of" Object="<c:out value='${stdgrd[1]}'/>"></InternalRelationship>
																</InternalRelationships>
															</Content-Query>
														</Query>
													</SMS-CSIP>													
												</c:when>
												<c:otherwise>
													<SMS-CSIP xmlns="http://sms.dlese.org" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
														<Query Color="skyblue" DetailLevel="Skeleton" Format="SMS">
															<Content-Query>
													                   <ObjectID Depth="2"><c:out value="${AllMaps}"></c:out></ObjectID>
															</Content-Query>
														</Query>
													</SMS-CSIP>										
												</c:otherwise>
											</c:choose>
										</c:param>
									</c:url>
									
									<x:parse var="bmks">
										<c:import url="${getAllBmks}"></c:import>
									</x:parse>
									
									<ol>
										<x:forEach select="$bmks//*[local-name()='itemRecord']">
										
											<c:set var="objType">
												<str:lowerCase>
													<x:out select="*[local-name()='Data']/*[local-name()='ObjectType']"/>
												</str:lowerCase>
											</c:set>
	
											<c:set var="objID">
												<x:out select="*[local-name()='Admin']/*[local-name()='IDNumber']"/>
											</c:set>
	
											<str:capitalize var="objName">
												<str:replace replace="&#034;" with="\"">
													<str:replace replace="&#039;" with="'">
														<x:out select="*[local-name()='Data']/*[local-name()='Name']"/>
													</str:replace>
												</str:replace>
											</str:capitalize>
											
											<c:if test="${objType=='benchmark'}">
												<li><a href="./NSDLbenchmarksContent.jsp?map=${AllMaps}&amp;bm=<c:out value='${objID}'/>"><c:out value="${objName}"/></a></li>
											</c:if>
										</x:forEach>
									</ol>


								</td>
							</tr>
						</table>
					</p>
					
					
					
					
	    		</td>
	    	</tr>
    	</table>
    </td>
  </tr>
</table>






</body>
</html>

