<%@ include file="../../TagLibIncludes.jsp" %>


<%-- Grab the required service URLs (defined in web.xml or server.xml): --%>
<c:set var="smsCsipBaseUrl" value="${initParam.smsCsipBaseUrl}" />
<c:set var="nsdlSearchBaseUrl" value="${initParam.nsdlSearchBaseUrl}" />
			
<%
String startingOffset = request.getParameter("startingOffset");
String mapTitle = request.getParameter("mapTitle");
String bmId = request.getParameter("bmId");
String map = request.getParameter("mapId");
String AAASCodeMod = request.getParameter("AAASCodeMod");
String displaytype = request.getParameter("displaytype");
String bmFullText = request.getParameter("bmFullText");
%>

<c:set var="startingOffset" value="<%=startingOffset%>"/>
<c:set var="mapTitle" value="<%=mapTitle%>"/>
<c:set var="bmId" value="<%=bmId%>"/>
<c:set var="map" value="<%=map%>"/>
<c:set var="AAASCodeMod" value="<%=AAASCodeMod%>"/>
<c:set var="displaytype" value="<%=displaytype%>"/>
<c:set var="bmFullText" value="<%=bmFullText%>"/>
<c:set var="bmFullText" value="${fn:replace(bmFullText,'\"','')}"/>
<c:set var="bmFullText" value="${fn:replace(bmFullText,'A.D.','AD')}"/>
<c:set var="bmFull" value=""/>
<c:forTokens var="bmParts" items="${bmFullText}" delims=".">
<c:choose>
<c:when test="${empty bmFull}">
	<c:set var='bmFull' value='"${bmParts}"'/>
</c:when>
<c:otherwise>
	<c:set var="bmFull">
		${bmFull} OR "${bmParts}"
	</c:set>
</c:otherwise>
</c:choose>

</c:forTokens>

<c:set var="query" value='(${bmFull} OR dct\:conformsTo:(("${bmId}")^2 OR (("AAAS") AND ("${mapTitle} ${AAASCodeMod}")))) NOT inCollection:oai\:nsdl.org\:crs\:2063768'/>
<%-- The maximum character length of the description that gets displayed in the initial search results. 
		A smaller value here will make the search results page more compact. Leave blank to 
		display the full description text regardles off its length --%>
<c:set var="maxDescriptionLength" value="400" />
<c:set var="maxTitleLength" value="90" />
<%-- The maximum character length of the URL that gets displayed in the UI. A smaller
		value here will prevent problems with HTML wrapping --%>
<c:set var="maxUrlLength" value="85" />
<%-- Set up the variables used for paging through results--%>
<c:set var="startingOffset"> 
	<c:if test="${empty startingOffset}">0</c:if> 
	<c:if test="${!empty startingOffset}"><c:out value="${startingOffset}"/></c:if> 
</c:set>
<%-- Issue the request to the web service. If a connection error occurs, store it in variable 'serviceError' --%>
<c:catch var="serviceError"> 
	<%-- Construct the http request to send to the web service and store it in variable 'webServiceRequest' --%>
	<c:url value="${nsdlSearchBaseUrl}" var="webServiceRequest"> 
		<%-- Define each of the http parameters used in the request --%>
		<c:param name="verb" value="Search"/> 
		<%-- Begin the result at the current offset --%>
		<c:param name="s" value="${startingOffset}"/> 
		<%-- Return 5 results --%>
		<c:param name="n" value="5"/> 
		<%-- Perform a textual search using the user's input --%>
		<c:param name="q" value="${query}"/> 
	</c:url> 

	<%-- Issue the request to the Web service server and store the response in variable 'xmlResponse' --%>
	<c:import url="${webServiceRequest}" var="xmlResponse" charEncoding="UTF-8" /> 
	<%-- Remove namespaces from the XML and create the DOM --%>
	<x:transform xslt="${f:removeNamespacesXsl()}" xml="${xmlResponse}" var="xmlDom"/> 
	<c:if test="${not empty serviceError}"> Sorry, our system has encountered a problem and we were unable to perform your search at this time. Please try again later. </c:if> 
	<%-- Display the record metadata to the user (if no connection error occured) --%>
	<c:if test="${empty serviceError}"> 
		<x:choose> 
				<%-- If the total number of results is greater than zero, display them --%>
				<x:when select="$xmlDom/NSDLSearchService/SearchResults/resultsInfo/totalNumResults > 0"> 
				<p>These resources were selected by performing a keyword search over items in the NSDL library.</p>
					<%-- ------ Begin paging logic ------ --%>
					<%-- Save the number of results in variable 'numResults' --%>
					<c:set var="numResults"> 
						<x:out select="$xmlDom/NSDLSearchService/SearchResults/resultsInfo/totalNumResults"/> 
					</c:set> 
					<c:set var="pageIndex"> 
					<%-- Create and store the HTML for the pager in variable 'pager' --%>
					
						<nobr> ${numResults > 1 ? 'results':'result'} 
						<c:out value="${startingOffset +1}"/> - 
						<c:if test="${startingOffset + 5 > numResults}"> 
							<c:out value="${numResults}"/> 
						</c:if> 
						<c:if test="${startingOffset + 5 <= numResults}"> 
							<c:out value="${startingOffset + 5}"/> 
						</c:if> 
						</nobr> 
						<nobr>out of <span id="numResults${section}"><c:out value="${numResults}"/></span></nobr> 
						<br/>
						<c:set var="page_prev"> 
							${startingOffset - 5}
						</c:set>
						<c:set var="page_next"> 
							${startingOffset + 5}
						</c:set>
						
						<c:if test="${(startingOffset - 5) >= 0 && param.view != 'print'}"> 
							<a href="javascript:updateResources(${startingOffset - 5},'${displaytype}')" onclick="resStrictPagerTrack('/content_click/tab/top_picks/${map}/${bmId}/page_${page_prev}_${startingOffset-1}/','page_${page_prev}_${startingOffset-1}');">&lt;&lt; Prev</a> &nbsp;
						</c:if> 
						<!--//The total number of pages we can display based on the number of search results//-->
						<c:set var="total_pages_full">${numResults div 5}</c:set>
						<c:set value="${fn:substringBefore(total_pages_full,'.')}" var="total_pages" />
						<c:set var="total_pages_fraction">${fn:substringAfter(total_pages_full,'.')}</c:set>
						<c:set var="total_pages_integer">${fn:substringBefore(total_pages_full,'.')}</c:set>
						<c:if test="${(total_pages_fraction > 0) && (total_pages_integer > 0)}">
							<c:set var="total_pages">${total_pages + 1}</c:set>
						</c:if>
						<!--//The result page we are currently on (add 1 to it)//-->
						<c:set var="current_page">${fn:substringBefore((startingOffset div 5), '.') + 1}</c:set>
						<!--// The number of page links we want to display in the pagination nav //-->
						<c:set var="set_page_display">11</c:set>
						<!--// Skip to this page number based on the page we're on //-->
						<c:set var="start_page">${current_page - (fn:substringBefore((set_page_display div 2), '.') + 1)}</c:set>
						<c:choose>
							<c:when test="${(total_pages > (set_page_display - 1)) && (current_page > (set_page_display/2))}">
								<c:set var="end_page">${current_page + fn:substringBefore(((set_page_display/2) - 1), '.')}</c:set>
							</c:when>
							<c:when test="${total_pages < (set_page_display - 1)}">
								<c:set var="end_page">${total_pages}</c:set>
							</c:when>
							<c:otherwise>
								<c:set var="end_page">${set_page_display - 1}</c:set>
							</c:otherwise>
						</c:choose>
					
						<c:choose>
							<c:when test="${start_page < 1}">
								<c:set var="start_page">1</c:set>
							</c:when>
							<c:when test="${end_page ge set_page_display}">
								<c:set var="start_page">${start_page + 1}</c:set>
							</c:when>
							<c:otherwise>
								<c:set var="start_page">${start_page}</c:set>
							</c:otherwise>
						</c:choose>
						<c:if test="${end_page ge total_pages}">
							<c:set var="end_page">${total_pages}</c:set>
						</c:if>
						<c:if test="${current_page >= 6}">
							<c:choose>
								<c:when test="${current_page >= 7}">
									<a href="javascript:updateResources(0,'${displaytype}')" onclick="resStrictPagerTrack('/content_click/tab/top_picks/${map}/${bmId}/page_0_4/','page_0_4');">1</a>...
								</c:when>
							</c:choose>
						</c:if>
						<c:if test="${total_pages > 1}">
							<c:forEach var="i" begin="${start_page}" end="${end_page}" varStatus="status">
								<c:choose>
									<c:when test="${i == current_page}">
										<strong>${i}</strong>
									</c:when>
									<c:otherwise>
										<c:set var="next_skip">${(i*5)-5}</c:set>
										<a href="javascript:updateResources(${next_skip},'${displaytype}')" onclick="resStrictPagerTrack('/content_click/tab/top_picks/${map}/${bmId}/page_${next_skip}_${next_skip+4}/','page_${next_skip}_${next_skip+4}');">${i}</a>
									</c:otherwise>
								</c:choose>
							</c:forEach>
						</c:if>
						<c:if test="${(current_page < (total_pages - 5)) && (total_pages > (set_page_display - 1))}">
							<c:set var="next_skip">${(total_pages*5)-5}</c:set>
							...<a href="javascript:updateResources(${next_skip},'${displaytype}')" onclick="resStrictPagerTrack('/content_click/tab/top_picks/${map}/${bmId}/page_${next_skip}_${next_skip+4}/','page_${next_skip}_${next_skip+4}');">${total_pages}</a>
						</c:if>
						<c:if test="${(startingOffset + 5) < numResults && param.view != 'print'}"> 
							<a href="javascript:updateResources(${startingOffset + 5},'${displaytype}')" onclick="resStrictPagerTrack('/content_click/tab/top_picks/${map}/${bmId}/page_${page_next}_${page_next+4}/','page_${page_next}_${page_next+4}');">Next &gt;&gt;</a> &nbsp;
						</c:if>
					</c:set>
					${pageIndex}
					<%-- ------ end paging logic ------ --%>
					<div id="resourceList">		
						<c:set var="mySectionIndex">
							itemIndex<c:out value="${section}"/>
						</c:set>
						<span id="${mySectionIndex}" class="navIndex">${pager}</span>
						<%-- Render a gray line --%>
						<hr/>
						<%-- Loop through each of the record nodes --%>
						<x:forEach select="$xmlDom/NSDLSearchService/SearchResults/results/document"> 
						<%-- We are already at XPath $xmlDom/NSDLSearchService/SearchResults/results/document
						so we can continue our path from there --%>
						<c:set var="resourceURL">
							<x:out select="header/resourceIdentifier"/>
						</c:set>
						<c:set var="resourceTitle">
							<x:out select="fields/title"/>
						</c:set>
						
						<c:set var="description">
							<x:out select="fields/compoundDescription"/> 
						</c:set>
						
						<c:set var="audience">
							<x:out select="fields/compoundAudience"/>
						</c:set>
						
						<c:set var="resourcePosition">
							<x:out select="position"/>
						</c:set>
						<c:set var="collectionId" value="" />
						<x:forEach select="fields/collContext">
							<c:choose>
								<c:when test="${empty collectionId}">
									<c:set var="collectionId"><x:out select="oai-id"/></c:set>
								</c:when>
								<c:otherwise>
									<c:set var="collectionId">${collectionId}|<x:out select="oai-id"/></c:set>
								</c:otherwise>
							</c:choose>		
						</x:forEach>
						
						<c:set var="gaTrackURL">
							/open_resource/tab/top_picks/${map}/${bmId}/
						</c:set>
						<c:set var="shortResURL">
							${fn:replace(resourceURL,'http://','')}
						</c:set>
						
						<p class="resource, stdlink" id="resourceItem">
							<div class="resourceTitle">
								<c:if test="${not empty maxTitleLength && fn:length(resourceTitle) > maxTitleLength}">	
									<%-- Make sure the truncation occurs on white space and not in the middle of a word --%>
										<c:set var="numChars" value="0"/>
										<c:set var="resourceTitle">	
											<c:set var="words" value="${fn:split( resourceTitle, ' ')}"/>
												<c:forEach items="${words}" var="word">
													<c:if test="${numChars < maxTitleLength}">
														${word} 
														<c:set var="numChars" value="${numChars + fn:length( word ) + 1}"/>
													</c:if>
												</c:forEach> 
												...
											</c:set>
										</c:if>	
									<a href='${resourceURL}' target="_blank" class="boldlink" onclick="gaTrackResource('${gaTrackURL}','${collectionId}','${shortResURL}','${resourcePosition}');">${resourceTitle}</a>
								</div>
								
								<div class="resourceUrl">
									<c:choose>
										<c:when test="${ fn:length(resourceURL) > maxUrlLength }">
											<a href="${resourceURL}" target="_blank" onclick="gaTrackResource('${gaTrackURL}','${collectionId}','${shortResURL}','${resourcePosition}');">${fn:substring(resourceURL,0,maxUrlLength)} ...</a>	
										</c:when>
										<c:otherwise>
											<a href="${resourceURL}" target="_blank" onclick="gaTrackResource('${gaTrackURL}','${collectionId}','${shortResURL}','${resourcePosition}');">${resourceURL}</a>
										</c:otherwise>
									</c:choose>
								</div>
								<div class="resourceDescription"> 
									<%-- Truncate the description text if necessary --%>
									<c:if test="${not empty maxDescriptionLength && fn:length(description) > maxDescriptionLength}">	
										<%-- Make sure the truncation occurs on white space and not in the middle of a word --%>
										<c:set var="numChars" value="0"/>
										<c:set var="description">	
											<c:set var="words" value="${fn:split( description, ' ')}"/>
											<c:forEach items="${words}" var="word">
												<c:if test="${numChars < maxDescriptionLength}">
													${word} 
													<c:set var="numChars" value="${numChars + fn:length( word ) + 1}"/>
												</c:if>
											</c:forEach> 
											...
										</c:set>
									</c:if>	
									${description}
									<str:encodeUrl var="encodeUrl">${fn:replace(resourceURL,'&amp;','&')}</str:encodeUrl>
									&nbsp;<a href="http://nsdl.org/search/?q=&verb=Search&s=0&n=10&item_num=0&identifier=${encodeUrl}&bm=${bm}&id=${map}">View More</a>
									
									<c:if test="${debug == '1'}">
										<c:set var="audienceLists" value="${fn:replace( audience, ' ~^',', ')}"/>
										<br/><strong>Audiences:</strong>
										<c:out value="${audienceLists}" />
									</c:if>
								</div>
							</p>
							<hr />
						</x:forEach> 
						<span id="${mySectionIndex}" class="navIndex">${pager}</span>
					</div>
					
					${pageIndex}
				</x:when> 
				<%-- If there were no matches, report to user --%>
				<x:otherwise> 
				</x:otherwise>	
			</x:choose> 

		</c:if> 
	</c:catch> 


