function validateOnSubmit() {
	var errorFree = '';
	var zip = validateZipcode();
	var role = validateRole();
	var grd = validateGrd();
	var purpose = validatePurpose();
	var purpose_success = validatePurposeSuccess();

	if(zip == false || role == false || grd == false || purpose == false || purpose_success == false){
		errorFree = false;
	} else {
		errorFree = true;
		return submitSurvey();
	}
	return false;
	
}

function validateZipcode(){
	var error = '';
	if(!$('not_us').checked){
		if(!$('zipcode').value){
			error = "Zipcode is Required. ";
		} else {
			if($('zipcode').value.length < 5){
				error = error + "Zipcode must be 5 numbers long. ";
			}
			if($('zipcode').value.search(/\D/) != -1){
				error = error + "Zipcode must only contain numbers. ";
			}
		}
		
		if(error){
			$('zipcode_error').update(error);
			$('zipcode_error').addClassName('error');
			return false;
		}
	}
	$('zipcode_error').update();
	$('zipcode_error').removeClassName('error');
	return true;
}

function validateRole(){
	var error = '';
	if(getRadioValue('role') == null){
		error = "Please identify yourself. ";
		$('role_error').update(error);
		$('role_error').addClassName('error');
		
		return false;
	}
	$('role_error').update();
	$('role_error').removeClassName('error');
	return true;
}
	
function validateGrd(){
	var error = '';
	if(!$('grd_elem').checked && !$('grd_middle').checked && 
	!$('grd_high').checked && !$('grd_underg').checked && 
	!$('grd_grad').checked && !$('grd_home').checked && 
	!$('grd_informal').checked && !$('grd_general').checked ){
		error = "Please indicate what grade level you are/work with. ";
		$('grd_error').update(error);
		$('grd_error').addClassName('error');
		
		return false;
	}
	$('grd_error').update();
	$('grd_error').removeClassName('error');
	return true;	
}	

function validatePurpose(){
	var error = '';
	if(getRadioValue('purpose') == null){
		error = "Please indicate your purpose for visiting NSDL today. ";
		$('purpose_error').update(error);
		$('purpose_error').addClassName('error');
		
		return false;
	} else if(getRadioValue('purpose') == 'Other'){
		if(!$('purpose_explain').value){
			error = "Please briefly describe your purpose. ";
			$('purpose_explain_error').update(error);
			$('purpose_explain_error').addClassName('error');
			
			$('purpose_error').update();
			$('purpose_error').removeClassName('error');
			return false;
		}
	}

	$('purpose_error').update();
	$('purpose_error').removeClassName('error');
	$('purpose_explain_error').update();
	$('purpose_explain_error').removeClassName('error');
	return true;
}

function validatePurposeSuccess(){
	var error = '';
	if(getRadioValue('purpose_success') == 'Not at all'){
		if(!$('purpose_success_explain').value){
			error = "Please briefly describe why you were not successful. ";
			$('purpose_success_explain_error').update(error);
			$('purpose_success_explain_error').addClassName('error');

			return false;
		}
	}
	$('purpose_success_explain_error').update();
	$('purpose_success_explain_error').removeClassName('error');
	return true;
}
function getRadioValue(idOrName) {
        var value = null;
        var element = document.getElementById(idOrName);
        var radioGroupName = null;  
        
        // if null, then the id must be the radio group name
        if (element == null) {
                radioGroupName = idOrName;
        } else {
                radioGroupName = element.name;     
        }
        if (radioGroupName == null) {
                return null;
        }
        var radios = document.getElementsByTagName('input');
        for (var i=0; i<radios.length; i++) {
                var input = radios[ i ];    
                if (input.type == 'radio' && input.name == radioGroupName && input.checked) {                          
                        value = input.value;
                        break;
                }
        }
        return value;
}