jQuery(document).ready(function($) {
	$.metadata.setType("attr", "validate");
	if(!readCookie('NSDL_Survey_Complete')){
	
		if(!readCookie('display_survey')){

			$("#nsdl_timed_popup").hide().css('visibility', 'visible');
		} else if(readCookie('display_survey') == 'TRUE'){

			setSurveyHeight('static');
			$("#nsdl_timed_popup").show().css('visibility', 'visible');
			$("#survey_title").html("Hide User Survey");
		} else if(readCookie('display_survey') == 'FALSE') {
			$("#nsdl_timed_popup").height(20).animate({"height": "20px"},"slow").css('visibility', 'visible');
			$("#survey_title").html("View User Survey");

		}

		if(!readCookie('NSDL_Survey')){
			var ts = Math.round(new Date().getTime() / 1000);
			createCookie("NSDL_Survey",ts); 
	 	}
	 	if(!readCookie('display_survey')){
	 		TSInterval = setInterval(checkTS, 10);
		}
	 	
	 	$('#nsdl_timed_popup_handle').click(function()
		{
	
			$("#nsdl_timed_popup").css({"height": "20px",
									"bottom": "0px",
									"right": "10px"
								});
			createCookie("display_survey",'FALSE'); 
			setupSurveyTitle();
		});	
		
		$(window).resize(function() {
		  setSurveyHeight('static');
		});
		
		if(jQuery().validate) {
			$("#nsdl_survey").validate({
				rules: {
					grd_elem: {
						required: function(elm){
							if(!$('#grd_middle:checked').val() && !$('#grd_high:checked').val() && !$('#grd_underg:checked').val() && !$('#grd_grad:checked').val() && !$('#grd_home:checked').val() && !$('#grd_informal:checked').val() && !$('#grd_general:checked').val() && !$('#grd_commcoll:checked').val() && !$('#grd_teached:checked').val()){
								return true;
							}
							return false;
						}
					},
					zipcode: {
						required: function(elm){
							if(!$('#not_us:checked').val()){
								return true;
							}
							return false;
						},
						minlength: 5	
					},
					purpose_explain: {
						required: function(elm){
							if($('#purpose_other:checked').val() == 'Other'){
								return true;
							}
							return false;
						}
					},
					purpose_success_explain: {
						required: function(elm){
							if($('#purpose_success_not:checked').val() == 'Not at all'){
								return true;
							}
							return false;
						}
					}
				},
				errorPlacement: function(error, element) {
					if(element.attr("name") == "grd_elem"){
						error.insertAfter("#grade_level_label");
					} else if(element.attr("name") == "purpose_explain"){
						error.insertAfter("#purpose_explain_label");
					} else if(element.attr("name") == "purpose_success_explain"){
						error.insertAfter("#purpose_success_explain_label");
					}
				},

				submitHandler: function(form) {
					$(form).ajaxSubmit({
						success: showResponse		
					});	
				},
				messages: {
					grd_elem: {
						required: "Please indicate what grade level you are/you work with"
					},
					zipcode: {
						required: "Zipcode is required",
						minlength: jQuery.format("5 characters required")
					},
					purpose_explain: {
						required: "Please briefly describe your main purpose for visiting NSDL today"
					},
					purpose_success_explain: {
						required: "Please briefly describe why you were not successful in fulfilling your purpose"
					}
				}
			});
		}
		$('#min_shortcut').click(function(){
			$("#nsdl_timed_popup").height(20).animate({"height": "20px"},"slow").css('visibility', 'visible');
			$("#survey_title").html("View User Survey");
			createCookie("display_survey",'FALSE'); 
			setupSurveyTitle();
		});
	}

	function showResponse(responseText, statusText, xhr, $form){
		$("#nsdl_timed_popup_content").html("<h2>Thank you for submitting the survey.</h2><p>This window will close in a few seconds. <a href='#' onclick=\"$('#nsdl_timed_popup').hide().css('visibility', 'hidden');\">Close Now</a></p>");
		setTimeout(closeNSDLSurvey, 3000);
		createCookie('NSDL_Survey_Complete',1,3);
		eraseCookie("NSDL_Survey");
		eraseCookie("display_survey");
	}
	function closeNSDLSurvey(){
		$('#nsdl_timed_popup').hide().css('visibility', 'hidden')
	}
	function init_validation(ifDivName, thenDivName)
	{
		if(ifDivName == 'purpose_other'){
			if($('#'+ ifDivName+':checked').val() == 'Other'){
			    $('#'+ thenDivName).rules("add", {
					required: true
				});
				$("#nsdl_survey").validate().element('#'+ thenDivName);
		    } else {
			   	$('#'+ thenDivName).rules("remove", "required");
			   	$("#nsdl_survey").validate().element('#'+ thenDivName);
		   	}
	   	} else if(ifDivName == 'purpose_success_not'){
		   	if($('#'+ ifDivName+':checked').val() == 'Not at all'){
			    $('#'+ thenDivName).rules("add", {
					required: true
				});
				$("#nsdl_survey").validate().element('#'+ thenDivName);
		    } else {
			   	$('#'+ thenDivName).rules("remove", "required");
			   	$("#nsdl_survey").validate().element('#'+ thenDivName);
		   	}
	   	} else if(ifDivName == 'not_us'){
		   	if($('#'+ ifDivName+':checked').val()  == '1'){
			    $('#'+ thenDivName).rules("remove", "required minlength");
			   	$("#nsdl_survey").validate().element('#'+ thenDivName);
		    } else {
			   $('#'+ thenDivName).rules("add", {
					required: true,
					minlength: 5
				});
			   	$("#nsdl_survey").validate().element('#'+ thenDivName);
		   	}
	   	}	
	}
	function setupSurveyTitle(){
		$('#nsdl_timed_popup_handle').unbind('click');
		
		if(readCookie('display_survey') == 'FALSE'){
			$("#survey_title").html("View User Survey");
			$('#nsdl_timed_popup_handle').click(function()
			{
				createCookie("display_survey",'TRUE'); 
				setSurveyHeight('animated');
				$("#survey_title").html("Hide User Survey");
				setupSurveyTitle();
			});	
		} else {
			$("#survey_title").html("Hide User Survey");
			$('#nsdl_timed_popup_handle').click(function()
			{
				createCookie("display_survey",'FALSE'); 
				$("#nsdl_timed_popup").css({"height": "20px",
										"bottom": "0px",
										"right": "10px"
									});
				$("#survey_title").html("View User Survey");
				setupSurveyTitle();
			});	
		}
	}
	function setSurveyHeight(displayType){
		if(readCookie('display_survey') == 'TRUE') {
			if($(window).height() < 215){
				var newHeight = '215';
				var newHeightContent = '195';
			} else if($(window).height() > 500){
				var newHeight = '400';
				var newHeightContent = '380';	
			} else {
				var newHeight = $(window).height() - 100;
				var newHeightContent = ($(window).height() - 125);
			}
			if(displayType == 'animated'){
				$("#nsdl_timed_popup").animate({"height": newHeight},1000);
				$("#nsdl_timed_popup_content").animate({"height": newHeightContent},1000);
			} else {
				$("#nsdl_timed_popup").css("height", newHeight+"px");
				$("#nsdl_timed_popup_content").css("height", newHeightContent+"px");
			}
		} else if(readCookie('display_survey') == 'FALSE'){
			$("#nsdl_timed_popup").height(20).animate({"height": "20px"},"slow").css('visibility', 'visible');
		}
	}
	function checkTS(){
		var ts = Math.round(new Date().getTime() / 1000);
		survey_cookie = readCookie('NSDL_Survey')
		var ts_diff = ts - survey_cookie;
		if(ts_diff > 45 && TSInterval){
			if(!readCookie('display_survey') || readCookie('display_survey') == 'TRUE'){
				createCookie("display_survey",'TRUE'); 
				setSurveyHeight('animated');
			} else if(readCookie('display_survey') == 'FALSE'){
				setupSurveyTitle();
			}
			clearInterval(TSInterval);
		} else {
			$("#nsdl_timed_popup").hide();
		}
	}
});